package jalview.datamodel.features;

public interface FeatureSourceI
{
  /**
   * Answers a name for the feature source (not necessarily unique)
   * 
   * @return
   */
  String getName();

  /**
   * Answers the 'long name' of an attribute given its id (short name or
   * abbreviation), or null if not known
   * 
   * @param attributeId
   * @return
   */
  String getAttributeName(String attributeId);

  /**
   * Sets the 'long name' of an attribute given its id (short name or
   * abbreviation).
   * 
   * @param id
   * @param name
   */
  void setAttributeName(String id, String name);

  /**
   * Answers the datatype of the attribute with given id, or null if not known
   * 
   * @param attributeId
   * @return
   */
  FeatureAttributeType getAttributeType(String attributeId);

  /**
   * Sets the datatype of the attribute with given id
   * 
   * @param id
   * @param type
   */
  void setAttributeType(String id, FeatureAttributeType type);
}
